﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel.DataAnnotations;

namespace SL_DG_MultiRowSel
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            //Your code
            var list = new List<TestData>();
            list.Add(new TestData() { Name = "Jason Bourne", Title = "Mr." });
            list.Add(new TestData() { Name = "Marie St.Jacques", Title = "Mrs." });
            list.Add(new TestData() { Name = "Alexander Conklin", Title = "Mr." });
            list.Add(new TestData() { Name = "David Webb", Title = "Mr." });
            list.Add(new TestData() { Name = "Gordon Webb", Title = "Mr." });
            list.Add(new TestData() { Name = "Joshua Webb", Title = "Master" });

            //Set ItemsSource
            c1DataGrid1.ItemsSource = list;

            //Set SelectionMode
            c1DataGrid1.SelectionMode = C1.Silverlight.DataGrid.DataGridSelectionMode.MultiRow;

            //Register presenter's MouseLeftButtonDown and MouseLeftButtonUp events
            this.c1DataGrid1.LoadedRowPresenter += (s, e) =>
            {
                e.Row.Presenter.MouseLeftButtonDown += new MouseButtonEventHandler(Presenter_MouseLeftButtonDown);
                e.Row.Presenter.MouseLeftButtonUp += new MouseButtonEventHandler(Presenter_MouseLeftButtonUp);
            };

            //Unregister presenter's MouseLeftButtonDown and MouseLeftButtonUp events
            this.c1DataGrid1.UnloadedRowPresenter += (s, e) =>
            {
                e.Row.Presenter.MouseLeftButtonDown -= new MouseButtonEventHandler(Presenter_MouseLeftButtonDown);
                e.Row.Presenter.MouseLeftButtonUp -= new MouseButtonEventHandler(Presenter_MouseLeftButtonUp);
            };
        }

        C1.Silverlight.DataGrid.DataGridRow row;
        //List to keep track of current selection
        List<C1.Silverlight.DataGrid.DataGridRow> selectedRows;

        void Presenter_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            selectedRows = this.c1DataGrid1.Selection.SelectedRows.ToList();
        }

        void Presenter_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            row = ((C1.Silverlight.DataGrid.DataGridRowPresenter)sender).Row;

            /* If CTRL key has been pressed the entire code is not needed anyways.
             * With SelectionMode set to MultiRow the grid will take care of 
             * addition/removal of rows from selection*/
            if ((!C1.Silverlight.KeyboardUtil.Ctrl))
            {
                Dispatcher.BeginInvoke(() =>
                {
                    if (selectedRows.Contains(row))
                    {
                        selectedRows.Remove(row);
                    }
                    else
                    {
                        selectedRows.Add(row);
                    }
                    //Clear selection before we impose a new one
                    c1DataGrid1.Selection.Clear();
                    foreach (var r in selectedRows)
                    {
                        this.c1DataGrid1.Selection.Add(r, r);
                    }
                });

            }
        }
    }

    public class TestData
    {
        public string Name { get; set; }
        public string Title { get; set; }
    }
}
